<?php

function remove_videocdn_files() {
	@unlink(ROOT_DIR . '/videocdn_install.php');
	@unlink(ROOT_DIR . '/videocdn_admin_install.php');
	@unlink(ROOT_DIR . '/videocdn_cron.php');
	@unlink(ENGINE_DIR . '/ajax/videocdn.php');
	@unlink(ENGINE_DIR . '/classes/videocdn.class.php');
	@unlink(ENGINE_DIR . '/data/videocdnconfig.php');
	@unlink(ENGINE_DIR . '/inc/videocdn.php');
	@unlink(ENGINE_DIR . '/skins/images/videocdn.png');
	@listdir(ENGINE_DIR . '/inc/videocdn');
	@listdir(ENGINE_DIR . '/skins/videocdn');
}

class videocdn {
	public $config;
	public $dle_config;
	public $dle_db;
	public $dle_tpl;

	public $copyright = 'VideoCDN <b>v1.1</b>';

	//    
	public $video_type = array(
		'movie' => '',
		'serial' => '',
	);

	//   
	public $fields = array(
		'title' => array(
			'' => '----',
			'title' => ' ',
		),
		'kinopoisk' => array(
			'' => '----',
		),
		'output' => array(
			'' => '----',
			'short_story' => ' ',
			'full_story' => ' ',
		),
	);

	public function __construct($dle_config, $dle_db, $dle_tpl = null) {
		//   
		$this->config = require_once ENGINE_DIR . '/data/videocdnconfig.php';

		//   
		$this->dle_config = $dle_config;
		
		//   
		$this->dle_db = $dle_db;
		
		//  
		$this->dle_tpl = $dle_tpl;

		//  . 
		$xfields = xfieldsload();
		if ($xfields) foreach ($xfields as $key => $value) {
			$this->fields['title']["{$value[0]}|xfield|{$value[3]}"] = ".  &raquo; {$value[1]}";
			$this->fields['kinopoisk']["{$value[0]}|xfield|{$value[3]}"] = ".  &raquo; {$value[1]}";
			$this->fields['output']["{$value[0]}|xfield|{$value[3]}"] = ".  &raquo; {$value[1]}";
		}
	}

	public function doMain() {
		//      
		include_once ENGINE_DIR . '/inc/videocdn/templates/main.php';
	}
	public function doSettings() {
		//   
		if (isset($_POST['settings'])) {
			//     
			if (isset($_POST['film_voice_save'])) {
				$arr = explode(',', $_POST['film_voice_save']);
				if ($arr)  {
					$this->dle_db->query("UPDATE " . PREFIX . "_videocdn_voice SET film_priority = '0'");
					
					foreach ($arr as $key => $value) {
						$val = explode('|', $value);

						$val[0] = intval($val[0]);
						$val[1] = intval($val[1]);

						$this->dle_db->query("UPDATE " . PREFIX . "_videocdn_voice SET film_priority = '{$val[0]}' WHERE id = '{$val[1]}'");
					}
				}
			}

			//     
			if (isset($_POST['serial_voice_save'])) {
				$arr = explode(',', $_POST['serial_voice_save']);
				if ($arr) {
					$this->dle_db->query("UPDATE " . PREFIX . "_videocdn_voice SET serial_priority = '0'");

					foreach ($arr as $key => $value) {
						$val = explode('|', $value);

						$val[0] = intval($val[0]);
						$val[1] = intval($val[1]);

						$this->dle_db->query("UPDATE " . PREFIX . "_videocdn_voice SET serial_priority = '{$val[0]}' WHERE id = '{$val[1]}'");
					}
				}
			}

			//  
			$data = "<?php\r\n\r\nreturn array(";
			foreach ($_POST['settings'] as $key => $value) {
				if ($key == 'allowgroups' || $key == 'cron_cats')
					$value = implode(',', $value);

				if ($key == 'fields')
					$value = implode('|', $value);

				$key = addslashes(trim($key));
				$value = addslashes(trim($value));

				$data .= "\r\n\t'{$key}' => '{$value}',";
			}
			$data .= "\r\n);";
			
			//    
			$fh = fopen(ENGINE_DIR . '/data/videocdnconfig.php', 'w');
			fwrite($fh, $data);
			fclose($fh);

			header('Location: ?mod=videocdn&action=settings&success=1');
		}

		$source = file_get_contents('https://videocdn.tv/api/translations?api_token=' . $this->config['api_token']);
		if ($source) {
			$voice = json_decode($source, true);

			if ($voice && $voice['result'] && $voice['data']) {
				foreach ($voice['data'] as $item) {
					$_voice = $this->dle_db->super_query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE voice_id = '{$item['id']}'");

					if (!$_voice) {
						if ($this->dle_config['charset'] == 'windows-1251')
							$item['title'] = iconv('utf-8', 'windows-1251', $item['title']);

						$voice_id = intval($item['id']);
						$voice_name = $this->dle_db->safesql($item['title']);

						$this->dle_db->query("INSERT INTO " . PREFIX . "_videocdn_voice (id, voice_id, voice_name) VALUES (null, '$voice_id', '$voice_name')");
					}
				}

				$film_voice_use = array();
				$voice_use_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE film_priority > 0 ORDER BY film_priority ASC");
				while ($voice_use_row = $voice_use_result->fetch_assoc()) {
					$film_voice_use[] = $voice_use_row;
				}

				$film_voice_off = array();
				$voice_off_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE film_priority = 0 ORDER BY voice_id ASC");
				while ($voice_off_row = $voice_off_result->fetch_assoc()) {
					$film_voice_off[] = $voice_off_row;
				}

				$serial_voice_use = array();
				$voice_use_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE serial_priority > 0 ORDER BY serial_priority ASC");
				while ($voice_use_row = $voice_use_result->fetch_assoc()) {
					$serial_voice_use[] = $voice_use_row;
				}

				$serial_voice_off = array();
				$voice_off_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE serial_priority = 0 ORDER BY voice_id ASC");
				while ($voice_off_row = $voice_off_result->fetch_assoc()) {
					$serial_voice_off[] = $voice_off_row;
				}

				$voice_settings = true;
			}
		}

		//     
		include_once ENGINE_DIR . '/inc/videocdn/templates/settings.php';
	}
	public function doReplace() {
		//     
		$post = $this->dle_db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_post");
		
		//        /
		include_once ENGINE_DIR . '/inc/videocdn/templates/replace.php';
	}
	public function doDelete() {
		global $db;

		//      VideoCDN
		$videocdn_code_button = "\r\n// videocdn search begin\r\n\r\nrequire_once ENGINE_DIR . '/inc/videocdn/init.php';\r\n\$output .= \$videocdn->get_button();\r\n\r\n// videocdn search end\r\n";

		//     VideoCDN
		$videocdn_code_player = "\r\n// videocdn player begin\r\n\r\nrequire_once ENGINE_DIR . '/inc/videocdn/init.php';\r\n\$videocdn->add_player(\$row);\r\n\r\n// videocdn player end\r\n";

		$addnews_source = file_get_contents(ENGINE_DIR . '/inc/addnews.php');
		$editnews_source = file_get_contents(ENGINE_DIR . '/inc/editnews.php');
		$showfull_source = file_get_contents(ENGINE_DIR . '/modules/show.full.php');

		$addnews_source = str_replace($videocdn_code_button, '', $addnews_source);
		$editnews_source = str_replace($videocdn_code_button, '', $editnews_source);
		$showfull_source = str_replace($videocdn_code_player, '', $showfull_source);

		file_put_contents(ENGINE_DIR . '/inc/addnews.php', $addnews_source);
		file_put_contents(ENGINE_DIR . '/inc/editnews.php', $editnews_source);
		file_put_contents(ENGINE_DIR . '/modules/show.full.php', $showfull_source);

		$db->query("DROP TABLE IF EXISTS " . PREFIX . "_videocdn_voice");

		require_once ENGINE_DIR . '/api/api.class.php';

		$dle_api->uninstall_admin_module('videocdn');

		register_shutdown_function('remove_videocdn_files');

		die("<p> <b>VideoCDN</b>     !</p>");
	}

	/**
	 *   API videocdn
	 *
	 * @param int $out_base_id id    
	 * @param string $out_field_id    id    
	 * @param string $title   /
	 * @return array   /
	 */
	public function find($out_base_id = 0, $out_field_id = '', $title = '') {
		//    
		if (!$this->config['on'])
			return array('error' => 'module_is_disabled');

		if ($title && $this->dle_config['charset'] == 'windows-1251')
			$title = iconv('windows-1251', 'utf-8', $title);

		$api_url = "https://videocdn.tv/api/short?api_token={$this->config['api_token']}";

		if ($out_base_id && $out_field_id)
			$api_url .= "&{$out_field_id}={$out_base_id}";
		else
			$api_url .= "&title=" . urlencode($title);
		
		//  cURL
		if ($ch = curl_init($api_url)) {
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$output = curl_exec($ch);
			curl_close($ch);
			
			if ($output) {
				$response = json_decode($output, true);

				$data = $response['data'];

				if ($this->config['domain']) {
					foreach ($data as $key => $item) {
						if ($item['iframe_src'])
							$response[$key]['iframe_src'] = preg_replace("#//[^/]+#i", $this->config['domain'], $item['iframe_src']);
					}
				}

				return $data;
			} else
				die('Error! cURL result empty');
		} else
			die('Error! cURL not found');
	}
	
	public function get_replace_threads($type, $threads, $last_post_id = array(), $category = '', $category_inverse = false) {
		if ($type == 2)
			$approve = 'approve = 1';
		elseif ($type == 3)
			$approve = 'approve = 0';

		if ($category) {
			$searchcategory = array();
			$category = explode(',', $category);
			foreach ($category as $category_id) {
				$searchcategory[] = get_sub_cats($category_id);
			}
			$searchcategory = implode('|', $searchcategory);

			if ($searchcategory)
				$searchcategory = "category" . ($category_inverse ? ' not' : '') . " regexp '[[:<:]]($searchcategory)[[:>:]]'";
		}
		
		if ($last_post_id) {
			$next_posts_id = array();
			$post_result = $this->dle_db->query("SELECT id FROM " . PREFIX . "_post WHERE id < {$last_post_id}" . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : '') . " ORDER BY id DESC LIMIT {$threads}");
			while ($post_row = $post_result->fetch_assoc()) {
				$next_posts_id[] = $post_row['id'];
			}
			
			if ($next_posts_id) {
				$result = array(
					'status' => 'ok',
					'next_posts_id' => $next_posts_id,
				);
			} else
				$result = array(
					'status' => 'end',
				);
		} else {
			$post = $this->dle_db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_post WHERE id <> 0 " . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : ''));
			if ($post['count']) {
				$next_posts_id = array();
				$post_result = $this->dle_db->query("SELECT id FROM " . PREFIX . "_post WHERE id <> 0 " . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : '') . " ORDER BY id DESC LIMIT {$threads}");
				while ($post_row = $post_result->fetch_assoc()) {
					$next_posts_id[] = $post_row['id'];
				}
				
				if ($next_posts_id) {
					$result = array(
						'status' => 'ok',
						'next_posts_id' => $next_posts_id,
						'count' => $post['count'],
					);
				} else
					$result = array(
						'status' => 'end',
					);
			} else
				$result = array(
					'status' => 'end',
					'code' => '#00',
				);
		}
		
		return $result;
	}
	public function replace_thread($post_id, $fields, $rewrite = 0) {
		$post = $this->dle_db->super_query("SELECT * FROM " . PREFIX . "_post WHERE id = {$post_id}");
		
		//   . 
		$xfieldsdata = xfieldsdataload($post['xfields']);
		
		//  
		$_field_output = explode('|', $this->config['output']);
		if (count($_field_output) == 3) {
			$output = $xfieldsdata[$_field_output[0]];
		} elseif (count($_field_output) == 1) {
			$output = $post[$_field_output[0]];
		}
		
		//  ID  
		foreach ($fields as $field_name) {
			$_field = explode('|', $this->config[$field_name]);
			$_value = $xfieldsdata[$_field[0]];

			if ($_value) {
				$out_base_id = $_value;
				$out_base_name = $field_name;
			}
		}
		
		if ($out_base_id && $out_base_name) {
			if ($output) {
				if ($rewrite) {
					$response = $this->find($out_base_id, $out_base_name, null);
					if ($response[0] and $response[0]['iframe_src']) {
						$iframe_src = $response[0]['iframe_src'];

						if ($response[0]['type'] == 'movie')
							$voice_type = 'film';
						else
							$voice_type = 'serial';

						switch ($this->config["{$voice_type}_quality"]) {
							case 1:
								foreach ($response as $item) {
									if ($item['quality']) {
										$iframe_src = $item['iframe_src'];
										break;
									}
								}
								break;

							case 2:
								$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
								while ($row = $result->fetch_assoc()) {
									foreach ($response as $item) {
										if ($item['translations'][0] == $row['voice_name']) {
											$iframe_src = $item['iframe_src'];
											break 2;
										}
									}
								}
								break;

							case 3:
								$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
								while ($row = $result->fetch_assoc()) {
									foreach ($response as $item) {
										if ($item['translations'][0] == $row['voice_name']) {
											$iframe_src = $item['iframe_src'];

											if ($item['quality']) {
												foreach ($response as $_item) {
													if ($_item['translations'][0] == $row['voice_name'] && $_item['quality']) {
														$iframe_src = $_item['iframe_src'];
														break;
													}
												}
											}

											break 2;
										}
									}
								}
								break;

							case 4:
								foreach ($response as $item) {
									if ($item['quality']) {
										$iframe_src = $item['iframe_src'];

										$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
										while ($row = $result->fetch_assoc()) {
											foreach ($response as $_item) {
												if ($_item['quality'] && $_item['translations'][0] == $row['voice_name']) {
													$iframe_src = $_item['iframe_src'];
													break 2;
												}
											}
										}

										break;
									}
								}
								break;
						}

						$_field_output = explode('|', $this->config['output']);
						if (count($_field_output) == 3) {
							$xfieldsdata[$_field_output[0]] = $iframe_src;
							
							$xfields = array();
							foreach ($xfieldsdata as $key => $value) {
								$value = str_replace('|', '&#124;', $value);
								$xfields[] = "$key|$value";
							}
							$xfields = implode('||', $xfields);

							$xfields = addslashes($xfields);
							
							$this->dle_db->query("UPDATE " . PREFIX . "_post SET xfields = '$xfields' WHERE id = {$post_id}");
						} elseif (count($_field_output) == 1) {
							$this->dle_db->query("UPDATE " . PREFIX . "_post SET {$_field_output[0]} = '{$iframe_src}' WHERE id = {$post_id}");
						}
						
						$result = array(
							'status' => 'ok',
						);
					} else
						$result = array(
							'status' => 'error',
							'code' => '#02',
						);
				} else
					$result = array(
						'status' => 'exist',
					);
			} else {
				$response = $this->find($out_base_id, $out_base_name, null);
				if ($response[0] and $response[0]['iframe_src']) {
					$iframe_src = $response[0]['iframe_src'];

					if ($response[0]['type'] == 'movie')
						$voice_type = 'film';
					else
						$voice_type = 'serial';

					switch ($this->config["{$voice_type}_quality"]) {
						case 1:
							foreach ($response as $item) {
								if ($item['quality']) {
									$iframe_src = $item['iframe_src'];
									break;
								}
							}
							break;

						case 2:
							$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
							while ($row = $result->fetch_assoc()) {
								foreach ($response as $item) {
									if ($item['translations'][0] == $row['voice_name']) {
										$iframe_src = $item['iframe_src'];
										break 2;
									}
								}
							}
							break;

						case 3:
							$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
							while ($row = $result->fetch_assoc()) {
								foreach ($response as $item) {
									if ($item['translations'][0] == $row['voice_name']) {
										$iframe_src = $item['iframe_src'];

										if ($item['quality']) {
											foreach ($response as $_item) {
												if ($_item['translations'][0] == $row['voice_name'] && $_item['quality']) {
													$iframe_src = $_item['iframe_src'];
													break;
												}
											}
										}

										break 2;
									}
								}
							}
							break;

						case 4:
							foreach ($response as $item) {
								if ($item['quality']) {
									$iframe_src = $item['iframe_src'];

									$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_videocdn_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
									while ($row = $result->fetch_assoc()) {
										foreach ($response as $_item) {
											if ($_item['quality'] && $_item['translations'][0] == $row['voice_name']) {
												$iframe_src = $_item['iframe_src'];
												break 2;
											}
										}
									}

									break;
								}
							}
							break;
					}

					$_field_output = explode('|', $this->config['output']);
					if (count($_field_output) == 3) {
						$xfieldsdata[$_field_output[0]] = $iframe_src;
						
						$xfields = array();
						foreach ($xfieldsdata as $key => $value) {
							$value = str_replace('|', '&#124;', $value);
							$xfields[] = "$key|$value";
						}
						$xfields = implode('||', $xfields);

						$xfields = addslashes($xfields);
						
						$this->dle_db->query("UPDATE " . PREFIX . "_post SET xfields = '$xfields' WHERE id = {$post_id}");
					} elseif (count($_field_output) == 1) {
						$this->dle_db->query("UPDATE " . PREFIX . "_post SET {$_field_output[0]} = '{$iframe_src}' WHERE id = {$post_id}");
					}
					
					$result = array(
						'status' => 'ok',
					);
				} else
					$result = array(
						'status' => 'error',
						'code' => '#03',
					);
			}
		} else
			$result = array(
				'status' => 'error',
				'code' => '#01',
			);

		$result['post'] = $post;
		$result['kinopoisk_id'] = $kinopoisk_id;
		$result['out_base_id'] = $out_base_id;
		$result['out_base_name'] = $out_base_name;

		if ($result['status'] == 'ok') {
			if ($this->dle_config['allow_alt_url']) {
				if ($this->dle_config['seo_type'] == 1 || $this->dle_config['seo_type'] == 2) {
					$result['post']['category'] = intval($result['post']['category']);
					if ($result['post']['category'] && $this->dle_config['seo_type'] == 2) {
						$full_link = $this->dle_config['http_home_url'] . get_url($result['post']['category']) . "/" . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					} else {
						$full_link = $this->dle_config['http_home_url'] . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					}
				} else {
					$full_link = $this->dle_config['http_home_url'] . date('Y/m/d/', $result['post']['date']) . $result['post']['alt_name'] . ".html";
				}
			} else {
				$full_link = $this->dle_config['http_home_url'] . "index.php?newsid=" . $result['post']['id'];
			}

			$log_string = " $full_link" . ($result['out_base_id'] ? " ({$result['out_base_name']}: {$result['out_base_id']})" : '') . "\r\n";
			file_put_contents(ENGINE_DIR . '/inc/videocdn/reports/success.log', $log_string, FILE_APPEND | LOCK_EX);
		}

		if ($result['status'] == 'exist') {
			if ($this->dle_config['allow_alt_url']) {
				if ($this->dle_config['seo_type'] == 1 || $this->dle_config['seo_type'] == 2) {
					$result['post']['category'] = intval($result['post']['category']);
					if ($result['post']['category'] && $this->dle_config['seo_type'] == 2) {
						$full_link = $this->dle_config['http_home_url'] . get_url($result['post']['category']) . "/" . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					} else {
						$full_link = $this->dle_config['http_home_url'] . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					}
				} else {
					$full_link = $this->dle_config['http_home_url'] . date('Y/m/d/', $result['post']['date']) . $result['post']['alt_name'] . ".html";
				}
			} else {
				$full_link = $this->dle_config['http_home_url'] . "index.php?newsid=" . $result['post']['id'];
			}

			$log_string = " $full_link" . ($result['out_base_id'] ? " ({$result['out_base_name']}: {$result['out_base_id']})" : '') . "\r\n";
			file_put_contents(ENGINE_DIR . '/inc/videocdn/reports/found.log', $log_string, FILE_APPEND | LOCK_EX);
		}
		
		return $result;
	}

	/**
	 *     videocdn
	 *
	 * @return string         
	 */
	public function get_button() {
		global $member_id;

		//    
		if (!$this->config['on'])
			return '';

		if (!in_array($member_id['user_group'], explode(',', $this->config['allowgroups'])))
			return '';
		
		//    
		ob_start();
		include_once ENGINE_DIR . '/inc/videocdn/templates/button.php';
		$button_template = ob_get_clean();

		//          DLE
		if ($this->dle_config['version_id'] < 10.2) {
			//    10.2
			$button_template = "<tr>
				<td width=\"140\" height=\"29\" style=\"padding-left:5px;\">VideoCDN:</td>
				<td>
					{$button_template}
				</td>
			</tr>";
		} else {
			//   10.2  
			$button_template = "<div class=\"form-group\">
				<label class=\"control-label col-lg-2\">VideoCDN:</label>
				<div class=\"col-lg-10\">
					{$button_template}
				</div>
			</div>";
		}
		
		return $button_template;
	}

	/**
	 *       videocdn
	 *
	 * @param object $tpl 
	 * @param array $row  
	 */
	public function add_player($row) {
		//    
		if (!$this->config['on'])
			return false;
		
		if ($this->config['on'] and $row and strpos($this->dle_tpl->copy_template, '{videocdn-player}') !== false) {
			//   . 
			$xfieldsdata = xfieldsdataload($row['xfields']);
			
			//  
			$_field = explode('|', $this->config['output']);
			if (count($_field) == 3) {
				$videocdn_video_url = $xfieldsdata[$_field[0]];
			} elseif (count($_field) == 1) {
				$videocdn_video_url = $row[$_field[0]];
			}
			
			//           
			if ($videocdn_video_url && $this->config['video_width'] && $this->config['video_height']) {
				//    
				$videocdn_player = "<iframe src=\"{$videocdn_video_url}\" width=\"{$this->config['video_width']}\" height=\"{$this->config['video_height']}\" frameborder=\"0\" allowfullscreen></iframe>";
				
				//  {videocdn-player}   
				$this->dle_tpl->copy_template = str_replace('{videocdn-player}', $videocdn_player, $this->dle_tpl->copy_template);
				
				//      [videocdn-player]...[/videocdn-player]       
				$this->dle_tpl->copy_template = str_replace('[videocdn-player]', '', $this->dle_tpl->copy_template);
				$this->dle_tpl->copy_template = str_replace('[/videocdn-player]', '', $this->dle_tpl->copy_template);
			//      
			} else {
				//     
				$this->dle_tpl->copy_template = str_replace('{videocdn-player}', '', $this->dle_tpl->copy_template);
				
				//      ,         [videocdn-player]...[/videocdn-player]
				$this->dle_tpl->copy_template = preg_replace("'\\[videocdn-player\\](.*?)\\[/videocdn-player\\]'is", '', $this->dle_tpl->copy_template);
			}
		}
	}
}